src/Solution/Web/Controllers/SuperUserController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using MyApp.Business.DomainObjects.Models;
using MyApp.Business.Services;
using MyApp.Web.ViewModels;
using OpenPlatform.General.Serialisation;
using OpenPlatform.General.Extensions;
using System.Collections;
using System.Resources;
using AutoMapper;
using System.Text.RegularExpressions;
using System.Reflection;
using System.Web.Security;
using Microsoft.Practices.Unity;
using System.IO;
using System.Text;

namespace MyApp.Web.Controllers
{

    [Authorize(Roles = "DEV,SUPERUSER")]
    public class SuperUserController : BaseController
    {
        private IAccountService _AccountService;
        private MyApp.Business.Services.IConfiguration _Configuration;
        private IEmailService _EmailService;
        private IQRCodeService _QRCodeService;


        public SuperUserController(IAccountService accountService, MyApp.Business.Services.IConfiguration configuration, IEmailService emailservice, IQRCodeService qrcodeservice)
        {
            _AccountService = accountService;
            _Configuration = configuration;
            _EmailService = emailservice;
            _QRCodeService = qrcodeservice;


        }


        public ActionResult Index()
        {

            Log.Debug(string.Format("SuperUserController ActionResult Index() {0} ", ""));

            SuperUserIndexViewModel viewmodel = new SuperUserIndexViewModel();

            viewmodel.QrCodeScale = 5;

            viewmodel.Isencrypted = 1;

            viewmodel.QrCodeData =  _AccountService.GetUserCache(GetLoggedInUserUserName()).Id.Encrypt();

            return View(viewmodel);
        }

        [HttpGet]
        public ActionResult DownloadUserPDF(string encryptedId)
        {
            Log.Debug(string.Format("ZoneController ActionResult DownloadUserPDF() {0} ", encryptedId));

            UserProfile selecteduser = _AccountService.GetUserCache(GetLoggedInUserUserName());

            StringBuilder sb = new StringBuilder();

            var cd = new System.Net.Mime.ContentDisposition
            {
                FileName = String.Format("QRCode_{0}.pdf", selecteduser.Id),
                Inline = false,
            };

            Response.Clear();
            Response.AppendHeader("Content-Disposition", cd.ToString());

            return File(_QRCodeService.GeneratePDFForUser(Server.MapPath("~/") + "Content\\Template\\UserPDFSheet.doc", selecteduser).ToArray(), "application/pdf");
        }




        #region helper methods


        #endregion



    }

}

src/Solution/Web/Controllers/ZoneController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Transactions;
using System.Web;
using System.Web.Mvc;
using System.Web.Security;
using MvcContrib;
using MyApp.Business.Services;
using MyApp.DAL.Repository;
using MyApp.Web.ViewModels;
using WebMatrix.WebData;
using OpenPlatform.General.Extensions;
using MyApp.Business.DomainObjects.Models;
using OpenPlatform.General.Encryption;
using System.Security;
using System.Text;
using System.Security.Cryptography;

namespace MyApp.Web.Controllers
{

    [Authorize(Roles = "DEV,SUPERUSER")]
    public class ZoneController : BaseController
    {
        private IAccountService _AccountService;
        private IConfiguration _Configuration;
        private ILog _Log;
        private IZoneService _ZoneService;
        private IQRCodeService _QRCodeService;


        public ZoneController(IAccountService accountService, IConfiguration configuration, ILog log, IZoneService zoneservice, IQRCodeService qrcodeservice)
        {
            _AccountService = accountService;
            _Configuration = configuration;
            _Log = Log;
            _ZoneService = zoneservice;
            _QRCodeService = qrcodeservice;
        }

        [HttpGet]
        public ActionResult Index()
        {
            Log.Debug(string.Format("ZoneController ActionResult Index() {0} ", ""));

            ZoneIndexViewModel viewmodel = new ZoneIndexViewModel();

            viewmodel.ListOfZones = new List<ZoneListViewModel>();

            foreach (Zone currentzone in _ZoneService.GetZonesOrderedByName(_AccountService.GetUserCache(GetLoggedInUserUserName()).Id, true))
            {
                ZoneListViewModel model = new ZoneListViewModel()
                {
                    Identifier = currentzone.Identifier,
                    IsActive = currentzone.IsActive ? "Y" : "N",
                    Name = currentzone.Name,
                    EncryptedId = currentzone.Id.Encrypt(),
                    TotalEngagement = _ZoneService.GetTotalEngagementsByZoneId(currentzone.Id),
                    TotalRegisteredEngagement = _ZoneService.GetTotalRegisteredEngagementsByZoneId(currentzone.Id),
                    TotalUnregisteredEngagement = _ZoneService.GetTotalUnregisteredEngagementsByZoneId(currentzone.Id),
                    DoesZoneHaveEngagements = false
                };

                if (model.TotalEngagement > 0)
                {
                    model.DoesZoneHaveEngagements = true;
                }


                viewmodel.ListOfZones.Add(model);
            }

            return View(viewmodel);

        }


        [HttpGet]
        public ActionResult AddEditZone(string zoneid)
        {
            Log.Debug(string.Format("ZoneController ActionResult AddEditZone() {0} ", zoneid));

            Zone selectezone = new Zone() { IsActive = true };

            if (zoneid.IsNotNullOrEmpty())
            {
                selectezone = _ZoneService.GetZoneById(zoneid.DecryptToInt());
            }

            ZoneAddEditViewModel viewmodel = new ZoneAddEditViewModel();
            viewmodel.EncryptedId = selectezone.Id.Encrypt();
            viewmodel.Identifier = selectezone.Identifier;
            viewmodel.IsActive = selectezone.IsActive;
            viewmodel.Name = selectezone.Name;

            return View(viewmodel);

        }


        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult AddEditZone(ZoneAddEditViewModel viewmodel)
        {
            Log.Debug(string.Format("ZoneController ActionResult AddEditZone() {0} ", ""));

            BusinessEnum.ZoneAdd addresult = BusinessEnum.ZoneAdd.Fail;

            if (ModelState.IsValid)
            {

                // edit
                if (viewmodel.EncryptedId.DecryptToInt() > 0)
                {
                    Zone editedzone = _ZoneService.GetZoneById(viewmodel.EncryptedId.DecryptToInt());
                    editedzone.IsActive = viewmodel.IsActive;
                    editedzone.Name = viewmodel.Name;

                    addresult = _ZoneService.Update(editedzone);
                }

                // add
                if (viewmodel.EncryptedId.DecryptToInt() == 0)
                {
                    Zone addedzone = new Zone();
                    addedzone.IsActive = true;
                    addedzone.Name = viewmodel.Name.TrimCheckForNull();
                    addedzone.Identifier = "--";
                    addedzone.UserProfileId = _AccountService.GetUserCache(GetLoggedInUserUserName()).Id;

                    addresult = _ZoneService.Add(addedzone);

                }

                if (addresult == BusinessEnum.ZoneAdd.DuplicateName)
                {
                    viewmodel.Feedbackmessage = MyApp.Web.Resources.EVAResource.zonenamealreadyexists;
                }
                else if (addresult == BusinessEnum.ZoneAdd.Fail)
                {
                    viewmodel.Feedbackmessage = MyApp.Web.Resources.EVAResource.failedtocompleterequest;
                }
                else
                {
                    return RedirectToAction("Index");
                }

            }

            return View(viewmodel);
        }



        [HttpGet]
        public ActionResult DownloadZonePDF(string zoneid)
        {
            Log.Debug(string.Format("ZoneController ActionResult DownloadZonePDF() {0} ", zoneid));

            Zone selectedzone = _ZoneService.GetZoneById(zoneid.DecryptToInt());

            StringBuilder sb = new StringBuilder();

            var cd = new System.Net.Mime.ContentDisposition
            {
                FileName = String.Format("Zone_{0}.pdf", selectedzone.Identifier),
                Inline = false,
            };

            Response.Clear();
            Response.AppendHeader("Content-Disposition", cd.ToString());

            return File(_QRCodeService.GeneratePDFForZone(Server.MapPath("~/") + "Content\\Template\\ZonePDFSheet.doc", selectedzone).ToArray(), "application/pdf");
        }


        [HttpGet]
        public ActionResult DeleteZone(string zoneid)
        {
            Log.Debug(string.Format("ZoneController ActionResult DeleteZone() {0} ", zoneid));

            _ZoneService.DeleteByZoneId(zoneid.DecryptToInt());

            return RedirectToAction("Index");
        }



        [HttpGet]
        public ActionResult ShowEngagementsByZone(string zoneid)
        {
            Log.Debug(string.Format("ZoneController ActionResult ShowEngagementsByZone() {0} ", zoneid));

            EngagementListViewModel viewmodel = new EngagementListViewModel();

            viewmodel.ListOfEngagements = new List<EngagementViewModel>();

            List<ZoneEngagement> listofengagements = _ZoneService.GetEngagementsByZone(zoneid.DecryptToInt());

            foreach (ZoneEngagement engagement in listofengagements)
            {
                EngagementViewModel model = new EngagementViewModel()
                {
                    Id = engagement.Id,
                    DateAdded = engagement.DateAdded,
                    Emailaddress = (engagement.UserProfileId.HasValue ? engagement.UserProfile.EmailAddress : MyApp.Web.Resources.EVAResource.unregistered),
                    UnregisteredCode = (engagement.UnregisteredId)
                };

                viewmodel.ListOfEngagements.Add(model);

            }


            return View(viewmodel);

        }



        #region Helpers



        #endregion
    }
}

src/Solution/Web/Views/Shared/_EmptyLayout.cshtml
@RenderBody()

src/Solution/Web/Views/Shared/_Feedback.cshtml
@model System.String

@if (!String.IsNullOrEmpty(Model))
{
    <div class="alert alert-danger">
        @Html.Raw(Model)
    </div>

}

src/Solution/Web/Views/Shared/_Layout.cshtml
@using Microsoft.Practices.Unity;
@using MyApp.Business.Services;
@using MyApp.Business.DomainObjects.Models;
<!DOCTYPE html>
<!--[if IE 7]>    <html class="no-js ie7 oldie" lang="en"> <![endif]-->
<!--[if IE 8]>    <html class="no-js ie8 oldie" lang="en"> <![endif]-->
<!--[if IE 9]>    <html class="no-js ie9 oldie" lang="en"> <![endif]-->
<!--[if gt IE 9]><!-->
<html class="no-js" lang="en">
<!--<![endif]-->

<head>
    <meta charset="utf-8" />
    <title>@ViewBag.Title</title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="">
    <meta name="author" content="">
    @Styles.Render("~/Content/css")
    @*@Scripts.Render("~/bundles/jquery")*@
    @* @Scripts.Render("~/bundles/modernizr")
        @Scripts.Render("~/bundles/globalize")
        @Scripts.Render("~/bundles/jqueryval")
        @Scripts.Render("~/bundles/bootstrapmin")
        @Scripts.Render("~/bundles/shims")*@

    <script src='@Url.Content("~/Scripts/jquery-1.10.2.min.js")' type="text/javascript"></script>

    <script src='@Url.Content("~/Scripts/jquery.validate.min.js")' type="text/javascript"></script>
    <script src='@Url.Content("~/Scripts/jquery.validate.min.js")' type="text/javascript"></script>
    <script src='@Url.Content("~/Scripts/jquery.validate.unobtrusive.min.js")' type="text/javascript"></script>
    <script src='@Url.Content("~/Scripts/jquery-ui-1.10.1.custom.js")' type="text/javascript"></script>


    <script src='@Url.Content("~/Scripts/bootstrap.min.js")' type="text/javascript"></script>

    <script src='@Url.Content("~/Scripts/jquery.globalize/globalize.js")' type="text/javascript"></script>
    <script src='@Url.Content("~/Scripts/jquery.globalize/cultures/globalize.culture.en-GB.js")' type="text/javascript"></script>
    <script src='@Url.Content("~/Scripts/bootstrap.min.js")' type="text/javascript"></script>
    <script src='@Url.Content("~/Scripts/op_keepalive.js")' type="text/javascript"></script>


    <script>
        $(document).ready(function () {
            Globalize.culture("en-GB");
            $.validator.methods.date = function (value, element) {
                if (Globalize.parseDate(value)) {
                    return true;
                }
                return false;
            };

            $(".date").datepicker({
                changeMonth: true,
                changeYear: true,
                dateFormat: 'dd/mm/yy',
                gotoCurrent: true,
                autoSize: true
            });

        });

    </script>
</head>
<body>
    <div class="container">
        <div class="row clearfix">
            <div class="row">
                <div class="col-xs-12 col-md-8"><h1>Event Scan</h1></div>
                <div class="col-xs-6 col-md-4"></div>
            </div>

            <div class="col-md-12 column">

                @RenderBody()
            </div>
        </div>
    </div>




    @*@RenderSection("scripts", required: false)*@


    <br />
    <br />
</body>
</html>

src/Solution/Web/Views/Shared/_Menu.cshtml
@using Microsoft.Practices.Unity;
@using MyApp.Business.Services;
@using MyApp.Business.DomainObjects.Models;
@model MyApp.Business.DomainObjects.Models.SessionModel

@{
    IUnityContainer myContainer = new UnityContainer();

    Configuration config = new Configuration(null, null);
    myContainer.RegisterInstance<IConfiguration>(config);

    string csvroles = Model.RolesUserInAsPipeSeparated;

    string teamroles = config.RoleTeam;

    string dev_shelladmin_shelluser_roles = String.Format("{0}|{1}|{2}", config.RoleDev, config.RoleShellAdmin, config.RoleShellUser);

    string dev_shelladmin_roles = String.Format("{0}|{1}", config.RoleDev, config.RoleShellAdmin);

    string devroles = config.RoleDev;

    Boolean canuseraccessphase2menus = false;

    string developerlogouttext = string.Empty;

    if (Model.EventTeamUserIsIn != null)
    {
        canuseraccessphase2menus = (Model.EventTeamUserIsIn.Phase1StatusId == (int)BusinessEnum.PhaseStatus.Approved ? true : false);

        canuseraccessphase2menus = false; // TODO turned off pahse 2 menus for the time being

    }




    // TOFO : set the active state of teh current menu section

    // taken out the report menu option until we do have reports available
    // new { LinkText=@MyApp.Web.Resources.GeneralResource.ReportingMenu, ActionName="EventReports",ControllerName="Admin",IsPhase2 = false, Roles=dev_shelladmin_shelluser_roles  },

    var menus = new[]
                {
                   new { LinkText=@MyApp.Web.Resources.GeneralResource.teamhome, ActionName="Index",ControllerName="Team",IsPhase2 = false, Roles=teamroles  },
                    new { LinkText=@MyApp.Web.Resources.GeneralResource.Phase2Technical, ActionName="#",ControllerName="Team",IsPhase2 = true, Roles=teamroles  },
                     new { LinkText=@MyApp.Web.Resources.GeneralResource.Logistics, ActionName="#",ControllerName="Team",IsPhase2 = true, Roles=teamroles  },
                      new { LinkText=@MyApp.Web.Resources.GeneralResource.Offtrackawards, ActionName="#",ControllerName="Team",IsPhase2 = true, Roles=teamroles  },
                      new { LinkText=@MyApp.Web.Resources.GeneralResource.TeamSettings, ActionName="Teamsettings",ControllerName="Team",IsPhase2 = false, Roles=teamroles  },
                       new { LinkText=@MyApp.Web.Resources.GeneralResource.ManageEvents, ActionName="EventIndex",ControllerName="Admin",IsPhase2 = false, Roles=dev_shelladmin_shelluser_roles  },
                       new { LinkText=@MyApp.Web.Resources.GeneralResource.ManageInstitutions, ActionName="Index",ControllerName="Institution",IsPhase2 = false, Roles=dev_shelladmin_shelluser_roles  },
                       new { LinkText=@MyApp.Web.Resources.GeneralResource.SystemUsers, ActionName="SystemUsers",ControllerName="System",IsPhase2 = false, Roles=dev_shelladmin_roles  },   
                       new { LinkText=@MyApp.Web.Resources.GeneralResource.Logout + developerlogouttext, ActionName="LogOff",ControllerName="Account",IsPhase2 = false, Roles="ALL"  }        
                };      
}

<div class="navbar container shell">


    @*   <a class="btn btn-navbar" data-toggle="collapse" data-target=".nav-collapse">
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </a>*@
    <div class="nav-collapse">
        <ul class="nav">
            @{
                        
                String[] roles = csvroles.Split('|');
                var links = from item in menus
                            where item.Roles.Split(new String[] { "|" }, StringSplitOptions.RemoveEmptyEntries)
                            .Any(x => roles.Contains(x) || x == "ALL")
                            select item;
                foreach (var link in links)
                {
                    if (link.IsPhase2 == false || canuseraccessphase2menus == true)
                    {
                <li>@Html.ActionLink(link.LinkText, link.ActionName, link.ControllerName)</li>
                    }
                }

                if (roles.Contains(devroles))
                {
                <li class="dropdown">
                    <a href="#" class="dropdown-toggle" data-toggle="dropdown">Dev Tools
                                <b class="caret"></b>
                    </a>
                    <ul class="dropdown-menu">
                        <li>@Html.ActionLink("Perform a Post-Install Check", "Postinstallationcheck", "DevTools", new { openplatform = true }, null)</li>
                        <li>@Html.ActionLink("Perform a JavaScript Unit Test", "QUnit", "DevTools")</li>
                        <li>@Html.ActionLink("Write Out System Logs for Log4Net", "ViewLog", "DevTools")</li>
                        <li>@Html.ActionLink("Send a test email to a specified email address", "SendTestEmail", "DevTools")</li>
                        <li>@Html.ActionLink("Clear and Empty Application stored cache", "ClearApplicationCache", "DevTools")</li>
                        <li>@Html.ActionLink("Write out the full application log", "WriteOutApplicationLog", "DevTools")</li>
                        <li>@Html.ActionLink("Decrypt / Encrypt a particular string", "Decrypt", "DevTools")</li>
                        <li>@Html.ActionLink("Show Test Page - Dev -------", "RHTestPage", "RHTest")</li>
                        <li>@Html.ActionLink("Change the passphrase for a user", "ChangePassphrase", "DevTools")</li>
                        <li>@Html.ActionLink("Show All Assets for a specific event", "ShowAllAssets", "DevTools")</li>
                         <li>@Html.ActionLink("Write out all event templates", "WriteAllEventTemplates", "DevTools")</li>
                         <li>@Html.ActionLink("Throw an exception error", "ThrowError", "DevTools")</li>
                         <li>@Html.ActionLink("Phase2 could have been submitted but haven't", "ShowPhase2NoSubmits", "DevTools")</li>
                         <li>@Html.ActionLink("Upload A New Default Email banner", "UplaodDefaultEmailBanner", "DevTools")</li>
                         <li>@Html.ActionLink("Write out regions and their associated countries", "Showregionsandcountries", "DevTools")</li>
                        <li>@Html.ActionLink("Write our all unverified / unconfirmed account", "ShowUnverifiedAccounts", "Admin")</li>
                        <li>@Html.ActionLink("Verify and confirm an unverified account", "VerifyEmailAccouuntByUserForfileId", "DevTools")</li>
                        <li>@Html.ActionLink("Get login address for a Team", "GetLoginForteamname", "DevTools")</li>
                         <li>@Html.ActionLink("Show Teams with 'not listed' for institution", "ShowAllNotListedInsitutionsTeams", "DevTools")</li>
                         <li>@Html.ActionLink("Display Event Team Phase Status by EventId", "ShowEventTeamStatusByEventId", "DevTools")</li>
                        <li>@Html.ActionLink("Generate Example EventTeam Report", "GenerateEventTeamReport", "DevTools")</li>
                         <li>@Html.ActionLink("Show all users who have an account but no team or event team", "ShowAccountsButNoTeam", "DevTools")</li>
                         <li>@Html.ActionLink("Change the email/login address for a user", "Changeloginaddress", "DevTools")</li>
                        <li>@Html.ActionLink("Unassign an event team from an event", "UnassignEventTeam", "DevTools")</li>
                        <li>@Html.ActionLink("Assign a user to a new country", "AssignUserToNewCountry", "DevTools")</li>
                        <li>@Html.ActionLink("Email Tests sends 10 (emails not being received)", "EmailTests", "DevTools")</li>
                        
                        

                        @* <li>@Html.ActionLink("Manage Countries (not for client release)", "CountryIndex", "Institution")</li>*@
                    </ul>
                </li>
                        
                }
            }

        </ul>
    </div>
</div>

src/Solution/Web/Views/Shared/_NavSuperUser.cshtml
@model System.String

@{
    string m1 = "";
    string m2 = "";
    string m3 = "";

    string defstr = "inactive";
    string active = "active";

    m1 = (Model == MyApp.Web.Resources.EVAResource.Home ? active : defstr);
    m2 = (Model == MyApp.Web.Resources.EVAResource.engagementzones ? active : defstr);
    m3 = (Model == MyApp.Web.Resources.EVAResource.unregisteredCodes ? active : defstr);
}

<div class="col-md-12 column">
    <div class="bs-example">
        <ul class="nav nav-pills">
            <li class="@m1">@Html.ActionLink(MyApp.Web.Resources.EVAResource.Home, "Index", "SuperUser")</li>
            <li class="@m2">@Html.ActionLink(MyApp.Web.Resources.EVAResource.engagementzones, "Index", "Zone")</li>
            <li class="@m3">@Html.ActionLink(MyApp.Web.Resources.EVAResource.unregisteredCodes, "Index", "Unregistered")</li>
        </ul>
    </div>
</div>

@*<div class="navbar-header">
    <button class="navbar-toggle" type="button" data-toggle="collapse" data-target=".bs-navbar-collapse">
        <span class="sr-only">Toggle navigation</span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
    </button>
    <a href="../" class="navbar-brand">Bootstrap</a>
</div>
<nav class="collapse navbar-collapse bs-navbar-collapse" role="navigation">
    <ul class="nav navbar-nav">
        <li>
            <a href="../getting-started">Getting started</a>
        </li>
        <li class="active">
            <a href="../css">CSS</a>
        </li>
        <li>
            <a href="../components">Components</a>
        </li>
        <li>
            <a href="../javascript">JavaScript</a>
        </li>
        <li>
            <a href="../customize">Customize</a>
        </li>
    </ul>
    <ul class="nav navbar-nav navbar-right">
        <li>
            <a href="../about">About</a>
        </li>
    </ul>
</nav>*@


src/Solution/Web/Views/Shared/_NoRecordsExist.cshtml

<div class="alert alert-warning">

    @MyApp.Web.Resources.EVAResource.NoRecordsExist
</div>
